package dev.shadowsoffire.apotheosis.util;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function5;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.placebo.codec.PlaceboCodecs;
import dev.shadowsoffire.placebo.json.NBTAdapter;
import java.util.Optional;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.level.Level;
import net.minecraftforge.registries.ForgeRegistries;

public class SupportingEntity {
  public static Codec<dev.shadowsoffire.apotheosis.util.SupportingEntity> CODEC;
  
  public final EntityType<?> entity;
  
  protected final CompoundTag nbt;
  
  protected final double x;
  
  protected final double y;
  
  protected final double z;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)ForgeRegistries.ENTITY_TYPES.getCodec().fieldOf("entity").forGetter(()), (App)PlaceboCodecs.nullableField(NBTAdapter.EITHER_CODEC, "nbt").forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.DOUBLE, "x", Double.valueOf(0.0D)).forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.DOUBLE, "y", Double.valueOf(0.0D)).forGetter(()), (App)PlaceboCodecs.nullableField((Codec)Codec.DOUBLE, "z", Double.valueOf(0.0D)).forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.util.SupportingEntity::new));
  }
  
  public SupportingEntity(EntityType<?> entity, Optional<CompoundTag> nbt, double x, double y, double z) {
    this.entity = entity;
    this.nbt = nbt.orElse(null);
    this.x = x;
    this.y = y;
    this.z = z;
  }
  
  public Mob create(Level level, double x, double y, double z) {
    Mob ent = (Mob)this.entity.m_20615_(level);
    if (this.nbt != null)
      ent.deserializeNBT(this.nbt); 
    ent.m_6034_(this.x + x, this.y + y, this.z + z);
    return ent;
  }
}
